Index: branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Algorithm/Detail.aspx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Algorithm/Detail.aspx	(revision 6290)
+++ branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Algorithm/Detail.aspx	(revision 6304)
@@ -23,9 +23,14 @@
         Algorithm p = ((AlgorithmModel)Model).Algorithm;
     %>
-    <table border="1">
+
+            <div class="hl-menuButtons">                 
+        <%: Html.ActionLink("Back to Index", "Index", null, new { @class = "hl-button-text-back" })%>
+        </div>
+
+    <table class="hl-table">
         <tr>
-            <td>
+            <th>
                 Id:
-            </td>
+            </th>
             <td>
                 <%: Html.Label(p.Id.ToString())%>
@@ -34,7 +39,7 @@
         </tr>
         <tr>
-            <td>
+            <th>
                 Name:
-            </td>
+            </th>
             <td>
                 <%: Html.TextBox("AlgorithmName", p.Name, p.Name)%>
@@ -42,7 +47,7 @@
         </tr>
         <tr>
-            <td>
+            <th>
                 Description:
-            </td>
+            </th>
             <td>
                 <%: Html.TextBox("AlgorithmDescription", p.Description, p.Description)%>
@@ -50,7 +55,7 @@
         </tr>
         <tr>
-            <td>
+            <th>
                 DataTypeName:
-            </td>
+            </th>
             <td>
                 <%: Html.TextBox("AlgorithmDataTypeName", p.DataTypeName, p.DataTypeName)%>
@@ -58,7 +63,7 @@
         </tr>
         <tr>
-            <td>
+            <th>
                 Algorith Class:
-            </td>
+            </th>
             <td>
                 <select name="AlgorithmClassId">
@@ -74,7 +79,7 @@
         </tr>
         <tr>
-            <td>
+            <th>
                 Platform:
-            </td>
+            </th>
             <td>
                 <select name="PlatformId">
@@ -90,7 +95,7 @@
         </tr>
         <tr>
-            <td>
+            <th>
                 Action:
-            </td>
+            </th>
             <td>
                 <input type="submit" value="save" />
@@ -104,9 +109,9 @@
     {%><br />
         <% Algorithm p = ((AlgorithmModel)Model).Algorithm; %>        
-        <table border="1">
+        <table class="hl-table">
             <tr>
-                <td>
+                <th>
                     File:
-                </td>
+                </th>
                 <td>
                     <%: Html.Hidden("AlgorithmId", p.Id.ToString(), p.Id.ToString())%>
@@ -115,13 +120,13 @@
             </tr>
             <tr>
-                <td>
+                <th>
                     Action:
-                </td>
+                </th>
                 <td>
                     <input type="submit" value="Upload file" />
                 </td>
             </tr>
-        </table>                              
-        <%: Html.ActionLink("back to Index","Index") %>
+        </table> 
+
         <% } %> 
         
Index: branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Algorithm/Index.aspx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Algorithm/Index.aspx	(revision 6290)
+++ branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Algorithm/Index.aspx	(revision 6304)
@@ -22,5 +22,5 @@
         <th>Description</th>
         <th>Type</th>
-        <th colspan="2">Actions</th>
+        <th>Actions</th>
       </tr>
     </thead>
@@ -38,10 +38,8 @@
           <%: Html.Label(p.DataTypeName)%>
         </td>
-        <td>
-          <%: Html.ActionLink("detail", "Detail", new { p.Id }, new { @class = "hl-icon-edit" })%>
-        </td>
-        <td>
-          <%: Html.ActionLink("delete", "Delete", new { p.Id }, new { @class = "hl-icon-delete" })%>
-        </td>
+                <td class="hl-iconcell">
+                    <%: Html.ActionLink("detail", "Detail", new { p.Id }, new { @class = "hl-icon-edit" })%>
+                    <%: Html.ActionLink("delete", "Delete", new { p.Id }, new { @class = "hl-icon-delete" })%>
+                </td>
       </tr>
       <% } %>
Index: branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Detail.aspx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Detail.aspx	(revision 6290)
+++ branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Detail.aspx	(revision 6304)
@@ -13,11 +13,13 @@
     <% { %>
     <h2>Detail</h2>
-
+            <div class="hl-menuButtons">                 
+        <%: Html.ActionLink("Back to Index", "Index", null, new { @class = "hl-button-text-back" })%>
+        </div>
     <% AlgorithmClass ac = ((AlgorithmClassModel)Model).AlgorithmClass; %>
-    <table border="1">
+    <table class="hl-table">
         <tr>
-            <td>
+            <th>
                 Id:
-            </td>
+            </th>
             <td>
                 <%: Html.Label(ac.Id.ToString())%>
@@ -26,7 +28,7 @@
         </tr>
         <tr>
-            <td>
+            <th>
                 Name:
-            </td>
+            </th>
             <td>
                 <%: Html.TextBox("AlgorithmClassName", ac.Name, ac.Name)%>
@@ -34,7 +36,7 @@
         </tr>
         <tr>
-            <td>
+            <th>
                 Description:
-            </td>
+            </th>
             <td>
                 <%: Html.TextBox("AlgorithmClassDescription", ac.Description, ac.Description)%>
@@ -42,7 +44,7 @@
         </tr>
         <tr>
-            <td>
+            <th>
                 Action:
-            </td>
+            </th>
             <td>
                 <input type="submit" value="save" />
@@ -50,5 +52,5 @@
         </tr>
     </table> 
-    <%: Html.ActionLink("back to Index","Index") %>
+   
     <% } %>
 </asp:Content>
Index: branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Index.aspx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Index.aspx	(revision 6290)
+++ branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Index.aspx	(revision 6304)
@@ -15,10 +15,18 @@
 
 <%  long? id = null;  %>
-    <%: Html.ActionLink("New AlgorithmClass", "Detail", new {id}) %>
-    <%: Html.ActionLink("Order ASC", "SortAsc")%>
-    <%: Html.ActionLink("Order DESC", "SortDesc")%>
+<div class="hl-menuButtons">
+    <%: Html.ActionLink("New AlgorithmClass", "Detail", new { id }, new { @class = "hl-button-text-plus" })%>
+</div>
 
-    <div style="height:150px; overflow:scroll;">
-        <table>
+
+        <table class="hl-dataTable">
+        <thead>
+        <tr>
+        <th>Name</th>
+        <th>Description</th>
+        <th>Actions</th>
+        </tr>
+        </thead>
+        <tbody>
             <!--// We get this from the Controller (Index)-->
             <% foreach (AlgorithmClass p in ((AlgorithmClassModel)Model).AlgorithmClasses) {  %>
@@ -30,13 +38,12 @@
                     <%: Html.Label(p.Description) %>
                 </td>
-                <td>
-                    <%: Html.ActionLink("detail", "Detail", new { p.Id })%>
-                </td>
-                <td>
-                    <%: Html.ActionLink("delete", "Delete",new {p.Id}) %>
+                <td class="hl-iconcell">
+                    <%: Html.ActionLink("detail", "Detail", new { p.Id }, new { @class = "hl-icon-edit" })%>
+                    <%: Html.ActionLink("delete", "Delete", new { p.Id }, new { @class = "hl-icon-delete" })%>
                 </td>
             </tr>
             <% } %>
+            </tbody>
         </table>
-    </div>       
+  
 </asp:Content>
Index: branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Problem/Detail.aspx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Problem/Detail.aspx	(revision 6290)
+++ branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Problem/Detail.aspx	(revision 6304)
@@ -23,9 +23,12 @@
         Problem p = ((ProblemModel)Model).Problem;
     %>
-    <table border="1">
+            <div class="hl-menuButtons">                 
+        <%: Html.ActionLink("Back to Index", "Index", null, new { @class = "hl-button-text-back" })%>
+        </div>
+    <table class="hl-table">
         <tr>
-            <td>
+            <th>
                 Id:
-            </td>
+            </th>
             <td>
                 <%: Html.Label(p.Id.ToString())%>
@@ -34,7 +37,7 @@
         </tr>
         <tr>
-            <td>
+            <th>
                 Name:
-            </td>
+            </th>
             <td>
                 <%: Html.TextBox("ProblemName", p.Name, p.Name)%>
@@ -42,7 +45,7 @@
         </tr>
         <tr>
-            <td>
+            <th>
                 Description:
-            </td>
+            </th>
             <td>
                 <%: Html.TextBox("ProblemDescription", p.Description, p.Description)%>
@@ -50,7 +53,7 @@
         </tr>
         <tr>
-            <td>
+            <th>
                 DataTypeName:
-            </td>
+            </th>
             <td>
                 <%: Html.TextBox("ProblemDataTypeName", p.DataTypeName, p.DataTypeName)%>
@@ -58,7 +61,7 @@
         </tr>
         <tr>
-            <td>
+            <th>
                 Problem Class:
-            </td>
+            </th>
             <td>
                 <select name="ProblemClassId">
@@ -74,7 +77,7 @@
         </tr>
         <tr>
-            <td>
+            <th>
                 Platform:
-            </td>
+            </th>
             <td>
                 <select name="PlatformId">
@@ -90,7 +93,7 @@
         </tr>
         <tr>
-            <td>
+            <th>
                 Action:
-            </td>
+            </th>
             <td>
                 <input type="submit" value="save" />
@@ -104,9 +107,9 @@
     {%><br />
         <% Problem p = ((ProblemModel)Model).Problem; %>        
-        <table border="1">
+        <table class="hl-table">
             <tr>
-                <td>
+                <th>
                     File:
-                </td>
+                </th>
                 <td>
                     <%: Html.Hidden("ProblemId", p.Id.ToString(), p.Id.ToString()) %>
@@ -115,7 +118,7 @@
             </tr>
             <tr>
-                <td>
+                <th>
                     Action:
-                </td>
+                </th>
                 <td>
                     <input type="submit" value="Upload file" />
@@ -123,5 +126,4 @@
             </tr>
         </table>                              
-        <%: Html.ActionLink("back to Index","Index") %>
         <% } %> 
         
Index: branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Problem/Index.aspx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Problem/Index.aspx	(revision 6290)
+++ branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Problem/Index.aspx	(revision 6304)
@@ -15,10 +15,18 @@
     
     <%  long? id = null;  %>
-    <%: Html.ActionLink("New Problem", "Detail", new {id}) %>
-    <%: Html.ActionLink("Order ASC", "SortAsc")%>
-    <%: Html.ActionLink("Order DESC", "SortDesc")%>
+    <div class="hl-menuButtons">
+    <%: Html.ActionLink("New Problem", "Detail", new { id }, new { @class = "hl-button-text-plus" })%>
+    </div>
 
-    <div style="height:150px; overflow:scroll;">
-        <table>
+        <table class="hl-dataTable">
+        <thead>
+        <tr>
+        <th>Name</th>
+        <th>Description</th>
+        <th>Type</th>
+        <th>Actions</th>
+        </tr>
+        </thead>
+        <tbody>
             <!--// We get this from the Controller (Index)-->
             <% foreach(Problem p in ((ProblemModel)Model).Problems) {  %>
@@ -33,13 +41,12 @@
                     <%: Html.Label(p.DataTypeName)%>
                 </td>
-                <td>
-                    <%: Html.ActionLink("detail", "Detail", new { p.Id })%>
-                </td>
-                <td>
-                    <%: Html.ActionLink("delete", "Delete",new {p.Id}) %>
+                <td class="hl-iconcell">
+                    <%: Html.ActionLink("detail", "Detail", new { p.Id }, new { @class = "hl-icon-edit" })%>
+                    <%: Html.ActionLink("delete", "Delete", new { p.Id }, new { @class = "hl-icon-delete" })%>
                 </td>
             </tr>
             <% } %>
+            </tbody>
         </table>
-    </div>       
+     
 </asp:Content>
Index: branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/ProblemClass/Detail.aspx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/ProblemClass/Detail.aspx	(revision 6290)
+++ branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/ProblemClass/Detail.aspx	(revision 6304)
@@ -14,11 +14,13 @@
     <% { %>
     <h2>Detail</h2>
-
+            <div class="hl-menuButtons">                 
+        <%: Html.ActionLink("Back to Index", "Index", null, new { @class = "hl-button-text-back" })%>
+        </div>
     <% ProblemClass pc = ((ProblemClassModel)Model).ProblemClass; %>
-    <table border="1">
+    <table class="hl-table">
         <tr>
-            <td>
+            <th>
                 Id:
-            </td>
+            </th>
             <td>
                 <%: Html.Label(pc.Id.ToString())%>
@@ -27,7 +29,7 @@
         </tr>
         <tr>
-            <td>
+            <th>
                 Name:
-            </td>
+            </th>
             <td>
                 <%: Html.TextBox("ProblemClassName", pc.Name, pc.Name)%>
@@ -35,7 +37,7 @@
         </tr>
         <tr>
-            <td>
+            <th>
                 Description:
-            </td>
+            </th>
             <td>
                 <%: Html.TextBox("ProblemClassDescription", pc.Description, pc.Description)%>
@@ -43,7 +45,7 @@
         </tr>
         <tr>
-            <td>
+            <th>
                 Action:
-            </td>
+            </th>
             <td>
                 <input type="submit" value="save" />
@@ -51,5 +53,4 @@
         </tr>
     </table> 
-    <%: Html.ActionLink("back to Index","Index") %>
     <% } %>
 </asp:Content>
Index: branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/ProblemClass/Index.aspx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/ProblemClass/Index.aspx	(revision 6290)
+++ branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/ProblemClass/Index.aspx	(revision 6304)
@@ -16,10 +16,17 @@
 
 <%  long? id = null;  %>
-    <%: Html.ActionLink("New ProblemClass", "Detail", new {id}) %>
-    <%: Html.ActionLink("Order ASC", "SortAsc")%>
-    <%: Html.ActionLink("Order DESC", "SortDesc")%>
+<div class="hl-menuButtons">
+    <%: Html.ActionLink("New ProblemClass", "Detail", new { id }, new { @class = "hl-button-text-plus" })%>
+</div>
 
-    <div style="height:150px; overflow:scroll;">
-        <table>
+        <table class="hl-dataTable">
+                <thead>
+        <tr>
+        <th>Name</th>
+        <th>Description</th>
+        <th>Actions</th>
+        </tr>
+        </thead>
+        <tbody>
             <!--// We get this from the Controller (Index)-->
             <% foreach (ProblemClass p in ((ProblemClassModel)Model).ProblemClasses) {  %>
@@ -31,13 +38,13 @@
                     <%: Html.Label(p.Description) %>
                 </td>
-                <td>
-                    <%: Html.ActionLink("detail", "Detail", new { p.Id })%>
+                <td class="hl-iconcell">
+                    <%: Html.ActionLink("detail", "Detail", new { p.Id }, new { @class = "hl-icon-edit" })%>
+                    <%: Html.ActionLink("delete", "Delete", new { p.Id }, new { @class = "hl-icon-delete" })%>
                 </td>
-                <td>
-                    <%: Html.ActionLink("delete", "Delete",new {p.Id}) %>
-                </td>
+
             </tr>
             <% } %>
+        </tbody>
         </table>
-    </div>       
+  
 </asp:Content>