Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Controllers/QueryController.cs
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Controllers/QueryController.cs	(revision 6314)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Controllers/QueryController.cs	(revision 6315)
@@ -45,10 +45,12 @@
 
             // Get runs from filter
-            
 
             QueryServiceClient client = Query.GetClientFactory();
 
-
-            long[] ids = client.GetRunIds((CombinedFilter)Session["Content"]);
+            long[] ids;
+            if (Session["Content"] != null)
+                ids = client.GetRunIds((CombinedFilter)Session["Content"]);
+            else
+                ids = new long[0];
 
             QueryModel qm = new QueryModel();
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Models/QueryModel.cs
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Models/QueryModel.cs	(revision 6314)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Models/QueryModel.cs	(revision 6315)
@@ -80,27 +80,4 @@
         }
 
-        // just 4 testing
-        //public IList<RunCollectionData> getTestRuns() {
-
-        //    QueryServiceClient client = Query.GetClientFactory();
-
-        //    if (client != null) {
-        //        IList<RunCollectionData> runs = new List<RunCollectionData>();
-
-        //        //long[] runIds = client.GetRunIds(new Filter());
-        //        //if (runIds.Length < cnt) cnt = runIds.Length;
-
-        //        long[] getRuns = new long[2] { 1, 2 };
-
-        //        IList<Run> runList = client.GetRuns(getRuns, false).ToList<Run>();
-
-        //        foreach (Run r in runList)
-        //            runs.Add(new RunCollectionData(r));
-
-        //        return runs;
-        //    }
-        //    return new List<RunCollectionData>();
-        //}
-
     }
 }
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionDetail.ascx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionDetail.ascx	(revision 6314)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionDetail.ascx	(revision 6315)
@@ -5,5 +5,5 @@
 <div id="RunDetailProperties">
 <table><tr><td>
-    <table>
+    <table class="hl-dataTable">
         <thead>
             <tr><th colspan="3">Result</th></tr>
@@ -11,10 +11,7 @@
         <tbody>
             <% IResult result = (RunCollectionData)Session["QueryRunDetail"];
-               foreach (PropertyInfo pi in typeof(IResult).GetProperties()) {
-                   RouteValueDictionary rvd = new RouteValueDictionary();
-                   rvd.Add("controller", "Query");
-                   rvd.Add("id", pi.Name); %>
+               foreach (PropertyInfo pi in typeof(IResult).GetProperties()) { %>
             <tr>
-                <td style="width: 5%;"><%= Ajax.ActionLink("detail", "DetailValue", rvd, new AjaxOptions { UpdateTargetId = "ctrlValue" })%></td>
+                <td style="width: 5%;"><%= Ajax.ActionLink("detail", "DetailValue/" + pi.Name, null, new AjaxOptions { UpdateTargetId = "ctrlValue" }, new { @class = "hl-icon-view" })%></td>
                 <td style="width: 45%;"><%= pi.Name %></td>
                 <td>
@@ -30,5 +27,5 @@
     </table>
 
-    <table>
+    <table class="hl-dataTable">
         <thead>
             <tr><th colspan="3">Parameter</th></tr>
@@ -41,5 +38,5 @@
                    rvd.Add("id", pi.Name); %>
             <tr>
-                <td style="width: 5%;"><%= Ajax.ActionLink("detail", "DetailValue", rvd, new AjaxOptions { UpdateTargetId = "ctrlValue" })%></td>
+                <td style="width: 5%;"><%= Ajax.ActionLink("detail", "DetailValue/" + pi.Name, null, new AjaxOptions { UpdateTargetId = "ctrlValue" }, new { @class = "hl-icon-view" })%></td>
                 <td style="width: 45%;"><%= pi.Name %></td>
                 <td>
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionTable.ascx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionTable.ascx	(revision 6314)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionTable.ascx	(revision 6315)
@@ -4,5 +4,5 @@
 
 <div id="RunCollectionTable" style="overflow: auto; width: 100%">
-    <table>
+    <table class="hl-dataTable">
         <thead>
             <tr>
@@ -15,11 +15,7 @@
         <tbody>
             <% IList<RunCollectionData> data = (IList<RunCollectionData>) Session["QueryRuns"];
-               foreach (RunCollectionData rcd in data) { 
-                   RouteValueDictionary rvd = new RouteValueDictionary();
-                   rvd.Add("controller", "Query");
-                   rvd.Add("id", rcd.Id);
-                   %>
+               foreach (RunCollectionData rcd in data) { %>
                 <tr>
-                    <td><%: Html.ActionLink("details", "Details", rvd) %></td>
+                    <td><%: Html.ActionLink("details", "Details", new { rcd.Id}, new { @class = "hl-icon-view"}) %></td>
 
                     <% foreach (PropertyInfo pi in typeof(RunCollectionData).GetProperties()) { %>