Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Chart/BubbleChart.ascx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Chart/BubbleChart.ascx	(revision 6315)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Chart/BubbleChart.ascx	(revision 6318)
@@ -3,18 +3,21 @@
 <%@ Register assembly="System.Web.DataVisualization, Version=4.0.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35" namespace="System.Web.UI.DataVisualization.Charting" tagprefix="asp" %>
 
-
+<div style="background-color: #eeeeee;border-style:solid;border-color:#aaa;border-width:1px;padding:10px;list-style-type:none;">
 <% using (Html.BeginForm("UpdateBubbleChart","Chart")) %>
 <% { %>
 
-<%: Html.Label("x axis")%>
+<%: Html.Label("X-Axis")%>
 <%: Html.DropDownList("valuesAxisXCombobox", new SelectList(((ChartModel)Model).valuesAxisX))%>
-
-<%: Html.Label("y axis")%>
+<br />
+<%: Html.Label("Y-Axis")%>
 <%: Html.DropDownList("valuesAxisYCombobox", new SelectList(((ChartModel)Model).valuesAxisY))%>
-
-<%: Html.Label("bubble size")%>
+<br />
+<%: Html.Label("Bubble Size")%>
 <%: Html.DropDownList("bubbleSizeCombobox", new SelectList(((ChartModel)Model).bubbleSize))%>
 
-<input type="submit" value="update chart" />
+<input type="submit" class="hl-icon-refresh" value="update chart" />
+</div>
+
+
 
 <% } %>
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Chart/Index.aspx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Chart/Index.aspx	(revision 6315)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Chart/Index.aspx	(revision 6318)
@@ -1,3 +1,7 @@
 ﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>
+
+<asp:Content ID="Content3" runat="server" ContentPlaceHolderID="SubMenuContent">
+   <% Html.RenderAction("Menu","Query"); %>
+</asp:Content>
 
 <asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
@@ -7,5 +11,5 @@
 <asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
 
-    <h2>Index (Chart)</h2>
+    <h2>Bubble Chart</h2>
 
 
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Filter/Filters.ascx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Filter/Filters.ascx	(revision 6315)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Filter/Filters.ascx	(revision 6318)
@@ -3,9 +3,6 @@
 <%@ Import Namespace="HLWebOKBQueryPlugin.OKBQueryService" %>
 <%@ Import Namespace="HLWebOKBQueryPlugin.ViewModels" %>
-
-
 <script src="/Scripts/MicrosoftAjax.js" type="text/javascript"></script>
 <script src="/Scripts/MicrosoftMvcValidation.js" type="text/javascript"></script>
-
 <script type="text/javascript">
     function setAction(action, id) {
@@ -16,151 +13,121 @@
 </script>
 
+<% using (Html.BeginForm("AddFilter", "Filter", FormMethod.Post, new { Name = "filterForm" })) %>
+<% {  %>
+<!-- Put all into a form that calls the "AddFilter" Action-->
+<%
+    CombinedFilter topFilter = ((FilterModel)Model).Content;
+%>
+<%: Html.Hidden("selectedFilter",null, new { Id = "selectedFilter" })%>
+<%: Html.Hidden("action", null, new { Id = "action" })%>
+<div>
+    <%
+        foreach (Filter fNode in topFilter.Filters) {
 
-<% Html.EnableClientValidation(); %>
- <% using (Html.BeginForm("AddFilter", "Filter", FormMethod.Post, new { Name = "filterForm" })) %>
-    <% {  %>  
-<!-- Put all into a form that calls the "AddFilter" Action-->
-
-    <%
-     CombinedFilter topFilter = ((FilterModel)Model).Content;
+            CombinedFilter currentFilter = (CombinedFilter)fNode;
+            string comboboxName = FilterModel.ComboboxName + "." + currentFilter.Id;
+            string hiddenName = FilterModel.ParentIdName + "." + currentFilter.Id;
     %>
-    <div><table>
-<tr><td>A<br />N<br />D</td><td>
-
-  <%: Html.Hidden("selectedFilter",null, new { Id = "selectedFilter" })%>
-       <%: Html.Hidden("action", null, new { Id = "action" })%>
-   
-           <%
-     foreach (Filter fNode in topFilter.Filters)
-     {
-
-         CombinedFilter currentFilter = (CombinedFilter)fNode;
-         string comboboxName = FilterModel.ComboboxName + "." + currentFilter.Id;
-         string hiddenName = FilterModel.ParentIdName + "." + currentFilter.Id;
-    %>
-    <table border="0"><tr><td>
-    <%: Html.Hidden(hiddenName, currentFilter.Id.ToString())%>
-    
-    <%: Html.DropDownList(comboboxName, new SelectList(((FilterModel)Model).AvailableFilterForCombobox, "FilterTypeName", "Label"))%>
-   
-   
-    <input type="button" name="submitButton" value="+" class="hl-button-text-plus"   onClick="setAction('add','<%: currentFilter.Id%>');" />
-   <!-- <input type="submit" name="submitButton" value="+.<%:currentFilter.Id%>"  />-->
-</td></tr><tr><td>
-<!-- Build the selected filters. The filtesr will be stored in the session and the
+    <ul style="background-color: #eeeeee;border-style:solid;border-color:#aaa;border-width:1px;padding:10px;list-style-type:none;">
+        <li>
+            <%: Html.Hidden(hiddenName, currentFilter.Id.ToString())%>
+            <%: Html.DropDownList(comboboxName, new SelectList(((FilterModel)Model).AvailableFilterForCombobox, "FilterTypeName", "Label"))%>
+            <input type="button" name="submitButton" value="+" class="hl-button-text-plus" onclick="setAction('add','<%: currentFilter.Id%>');" />
+            <!-- <input type="submit" name="submitButton" value="+.<%:currentFilter.Id%>"  />-->
+        </li>
+        <!-- Build the selected filters. The filtesr will be stored in the session and the
 Controller puts the current filters from the session into the model. Selected Filters
 will be iterated. -->
-<% if (currentFilter.Filters != null)
-   {
+        <% if (currentFilter.Filters != null) {
 
-       foreach (Filter f in currentFilter.Filters)
-       {
-           if (f != null)
-           {  %>
-
-           <tr><td>
-    <%
+               foreach (Filter f in currentFilter.Filters) {
+                   if (f != null) {  %>
+        <li style="background-color:#FFF380;padding:5px;margin:5px;">
+            <%
            
 
-     if ("StringComparisonFilter".Equals(f.GetType().Name))
-     {  %>
-    <% StringComparisonFilter filter = ((StringComparisonFilter)f); %>
-    <%: Html.Label(filter.Label)%>
-    <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.StringComparisons, "Value", "Text", (int)filter.Comparison))%>   
-    <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, (filter.Value))%>
-    <%: Html.TextBoxFor(model => ((FilterModel)Model).IntValue, (filter.Value))%>
-    <%: Html.ValidationMessageFor(model => ((FilterModel)Model).IntValue)%>
-    <% }
-     else if ("NameStringComparisonFilter".Equals(f.GetType().Name))
-     { %>
-    <% NameStringComparisonFilter filter = ((NameStringComparisonFilter)f); %>
-    <%: Html.Label(filter.Label)%>
-    <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.StringComparisons, "Value", "Text", (int)filter.Comparison))%>   
-    <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
-    <% }
-     else if ("StringComparisonAvailableValuesFilter".Equals(f.GetType().Name))
-     { %>
-    <% StringComparisonAvailableValuesFilter filter = ((StringComparisonAvailableValuesFilter)f); %>
-    <%: Html.Label(filter.Label)%>
-    <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.StringComparisons, "Value", "Text", (int)filter.Comparison))%>   
-    <%: Html.DropDownList(f.Id + "." + FilterModel.ValueTextbox, new SelectList(filter.AvailableValues, filter.Value))%>
-    <% }
-     else if ("NameEqualityComparisonByteArrayFilter".Equals(f.GetType().Name))
-     { %>
-    <% NameEqualityComparisonByteArrayFilter filter = ((NameEqualityComparisonByteArrayFilter)f); %>
-    <%: Html.Label(filter.Label)%>
-    <%: Html.Label("not supported")%>
-    <% }
-     else if ("NameEqualityComparisonBoolFilter".Equals(f.GetType().Name))
-     { %>
-    <% NameEqualityComparisonBoolFilter filter = ((NameEqualityComparisonBoolFilter)f);   %>
-    <%: Html.Label(filter.Label)%>
-    <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.BoolComparisons, "Value", "Text", (int)filter.Comparison))%>      
-    <%: Html.DropDownList(f.Id + "." + FilterModel.ValueDropDownList, new SelectList(((FilterModel)Model).BoolStates, filter.Value))%>
-    <% }
-     else if ("NameOrdinalComparisonIntFilter".Equals(f.GetType().Name))
-     { %>
-    <% NameOrdinalComparisonIntFilter filter = ((NameOrdinalComparisonIntFilter)f);   %>
-    <%: Html.Label(filter.Label)%>
-    <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.OrdinalComparisons, "Value", "Text", (int)filter.Comparison))%>
-    <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
-    <% }
-     else if ("NameStringComparisonAvailableValuesFilter".Equals(f.GetType().Name))
-     { %>
-    <% NameStringComparisonAvailableValuesFilter filter = ((NameStringComparisonAvailableValuesFilter)f);   %>
-    <%: Html.Label(filter.Label)%>
-    <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.StringComparisons, "Value", "Text", (int)filter.Comparison))%>   
-    <%: Html.DropDownList(f.Id + "." + FilterModel.ValueDropDownList, new SelectList(filter.AvailableValues, filter.Value))%>
-    <% }
-     else if ("NameOrdinalComparisonDoubleFilter".Equals(f.GetType().Name))
-     { %>
-    <% NameOrdinalComparisonDoubleFilter filter = ((NameOrdinalComparisonDoubleFilter)f);   %>
-    <%: Html.Label(filter.Label)%>
-    <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.OrdinalComparisons, "Value", "Text", (int)filter.Comparison))%>
-    <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
-    <% }
-     else if ("NameOrdinalComparisonFloatFilter".Equals(f.GetType().Name))
-     { %>
-    <% NameOrdinalComparisonFloatFilter filter = ((NameOrdinalComparisonFloatFilter)f);   %>
-    <%: Html.Label(filter.Label)%>
-    <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.OrdinalComparisons, "Value", "Text", (int)filter.Comparison))%>
-    <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
-    <% }
-     else if ("NameOrdinalComparisonLongFilter".Equals(f.GetType().Name))
-     { %>
-    <% NameOrdinalComparisonLongFilter filter = ((NameOrdinalComparisonLongFilter)f);   %>
-    <%: Html.Label(filter.Label)%>
-    <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.OrdinalComparisons, "Value", "Text", (int)filter.Comparison))%>
-    <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
-    <% }
-     else if ("OrdinalComparisonDateTimeFilter".Equals(f.GetType().Name))
-     { %>
-    <% OrdinalComparisonDateTimeFilter filter = ((OrdinalComparisonDateTimeFilter)f);   %>
-    <%: Html.Label(filter.Label)%>
-    <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.OrdinalComparisons, "Value", "Text", (int)filter.Comparison))%>
-    <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
-    <% }                 
+                if ("StringComparisonFilter".Equals(f.GetType().Name)) { 
+            %>
+            <% StringComparisonFilter filter = ((StringComparisonFilter)f); %>
+            <%: Html.Label(filter.Label)%>
+            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.StringComparisons, "Value", "Text", (int)filter.Comparison))%>
+            <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, (filter.Value))%>
+            <% }
+                                else if ("NameStringComparisonFilter".Equals(f.GetType().Name)) { %>
+            <% NameStringComparisonFilter filter = ((NameStringComparisonFilter)f); %>
+            <%: Html.Label(filter.Label)%>
+            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.StringComparisons, "Value", "Text", (int)filter.Comparison))%>
+            <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
+            <% }
+                                else if ("StringComparisonAvailableValuesFilter".Equals(f.GetType().Name)) { %>
+            <% StringComparisonAvailableValuesFilter filter = ((StringComparisonAvailableValuesFilter)f); %>
+            <%: Html.Label(filter.Label)%>
+            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.StringComparisons, "Value", "Text", (int)filter.Comparison))%>
+            <%: Html.DropDownList(f.Id + "." + FilterModel.ValueTextbox, new SelectList(filter.AvailableValues, filter.Value))%>
+            <% }
+                                else if ("NameEqualityComparisonByteArrayFilter".Equals(f.GetType().Name)) { %>
+            <% NameEqualityComparisonByteArrayFilter filter = ((NameEqualityComparisonByteArrayFilter)f); %>
+            <%: Html.Label(filter.Label)%>
+            <%: Html.Label("not supported")%>
+            <% }
+                                else if ("NameEqualityComparisonBoolFilter".Equals(f.GetType().Name)) { %>
+            <% NameEqualityComparisonBoolFilter filter = ((NameEqualityComparisonBoolFilter)f);   %>
+            <%: Html.Label(filter.Label)%>
+            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.BoolComparisons, "Value", "Text", (int)filter.Comparison))%>
+            <%: Html.DropDownList(f.Id + "." + FilterModel.ValueDropDownList, new SelectList(((FilterModel)Model).BoolStates, filter.Value))%>
+            <% }
+                                else if ("NameOrdinalComparisonIntFilter".Equals(f.GetType().Name)) { %>
+            <% NameOrdinalComparisonIntFilter filter = ((NameOrdinalComparisonIntFilter)f);   %>
+            <%: Html.Label(filter.Label)%>
+            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.OrdinalComparisons, "Value", "Text", (int)filter.Comparison))%>
+            <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
+            <% }
+                                else if ("NameStringComparisonAvailableValuesFilter".Equals(f.GetType().Name)) { %>
+            <% NameStringComparisonAvailableValuesFilter filter = ((NameStringComparisonAvailableValuesFilter)f);   %>
+            <%: Html.Label(filter.Label)%>
+            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.StringComparisons, "Value", "Text", (int)filter.Comparison))%>
+            <%: Html.DropDownList(f.Id + "." + FilterModel.ValueDropDownList, new SelectList(filter.AvailableValues, filter.Value))%>
+            <% }
+                                else if ("NameOrdinalComparisonDoubleFilter".Equals(f.GetType().Name)) { %>
+            <% NameOrdinalComparisonDoubleFilter filter = ((NameOrdinalComparisonDoubleFilter)f);   %>
+            <%: Html.Label(filter.Label)%>
+            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.OrdinalComparisons, "Value", "Text", (int)filter.Comparison))%>
+            <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
+            <% }
+                                else if ("NameOrdinalComparisonFloatFilter".Equals(f.GetType().Name)) { %>
+            <% NameOrdinalComparisonFloatFilter filter = ((NameOrdinalComparisonFloatFilter)f);   %>
+            <%: Html.Label(filter.Label)%>
+            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.OrdinalComparisons, "Value", "Text", (int)filter.Comparison))%>
+            <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
+            <% }
+                                else if ("NameOrdinalComparisonLongFilter".Equals(f.GetType().Name)) { %>
+            <% NameOrdinalComparisonLongFilter filter = ((NameOrdinalComparisonLongFilter)f);   %>
+            <%: Html.Label(filter.Label)%>
+            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.OrdinalComparisons, "Value", "Text", (int)filter.Comparison))%>
+            <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
+            <% }
+                                else if ("OrdinalComparisonDateTimeFilter".Equals(f.GetType().Name)) { %>
+            <% OrdinalComparisonDateTimeFilter filter = ((OrdinalComparisonDateTimeFilter)f);   %>
+            <%: Html.Label(filter.Label)%>
+            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.OrdinalComparisons, "Value", "Text", (int)filter.Comparison))%>
+            <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
+            <% }                 
                   
+            %>
+            <!-- <input type="submit" name="submitButton" value="-.<%:f.Id%>"  class="hl-icon-delete"  style="text-indent:-999em;"  />
+       -->
+            <input type="button" name="submitButton" value="-" class="hl-icon-delete" onclick="setAction('delete','<%: f.Id%>');" />
+            <% } // if%>
+        </li>
+        <% } // inner foreach %>
+    </ul>
+     <% } // if%>
+    <% 
+           }// foreach
     %>
-       <!-- <input type="submit" name="submitButton" value="-.<%:f.Id%>"  class="hl-icon-delete"  style="text-indent:-999em;"  />
-       -->
-    <input type="button" name="submitButton" value="-"  class="hl-icon-delete"  onClick="setAction('delete','<%: f.Id%>');" />
-   
-<% }%>
-    </td></tr>
-    <% } %>
-     </table></td></tr>
- <%  }%>
-   <% }%>
-
-
-
- 
-  </table> <input type="button" name="submitButton"  value="or"  onClick="setAction('or','');"  />
- </br>
- <input type="button" name="submitButton" value="runs"  onClick="setAction('runs','');" />
- 
- 
-<% }    
-%>
- </div>
+    <a    class="hl-button-text-plus" onclick="setAction('or','');" >OR Filter</a>
+    <a   class="hl-icon-refresh"  onclick="setAction('runs','');" >Refresh</a>
+    <%
+        }   // form 
+    %>
+</div>
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Filter/Results.aspx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Filter/Results.aspx	(revision 6315)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Filter/Results.aspx	(revision 6318)
@@ -4,4 +4,8 @@
 <%@ Import Namespace="HLWebOKBQueryPlugin.OKBQueryService" %>
 <%@ Import Namespace="HLWebOKBQueryPlugin.Helpers" %>
+
+<asp:Content ID="Content3" runat="server" ContentPlaceHolderID="SubMenuContent">
+   <% Html.RenderAction("Menu","Query"); %>
+</asp:Content>
 
 <asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/Menu.ascx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/Menu.ascx	(revision 6315)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/Menu.ascx	(revision 6318)
@@ -6,5 +6,5 @@
 </li>
 <li <% if(Session["SelectedSubMenu"] == "Results") {%> class="selected" <%}%>>
-    <%: Html.ActionLink("Results", "Results", "Query") %>
+    <%: Html.ActionLink("Tabular View", "Results", "Query") %>
 </li>
 <% if (Session["QueryRunDetailId"] != null) { %>