Index: branches/MPI/HeuristicLab 3.3.sln
===================================================================
--- branches/MPI/HeuristicLab 3.3.sln	(revision 6345)
+++ branches/MPI/HeuristicLab 3.3.sln	(revision 6346)
@@ -107,4 +107,5 @@
 		{E10F395F-C8A6-48AD-B470-9AA7A1F43809} = {E10F395F-C8A6-48AD-B470-9AA7A1F43809}
 		{B7A64A60-B538-479F-9C47-A3180C458F6C} = {B7A64A60-B538-479F-9C47-A3180C458F6C}
+		{C47EEE60-DF91-46DB-9B78-F2C2301D6FE7} = {C47EEE60-DF91-46DB-9B78-F2C2301D6FE7}
 		{6F18ED66-2333-4B5C-B882-AC99FB3CDCE5} = {6F18ED66-2333-4B5C-B882-AC99FB3CDCE5}
 		{4AE3FC69-C575-42D2-BC46-0FAD5850EFC5} = {4AE3FC69-C575-42D2-BC46-0FAD5850EFC5}
@@ -152,4 +153,5 @@
 		{EE2034D9-6E27-48A1-B855-42D45F69A4FC} = {EE2034D9-6E27-48A1-B855-42D45F69A4FC}
 		{A9EE65D9-405B-4C9C-B470-FC911AAC541B} = {A9EE65D9-405B-4C9C-B470-FC911AAC541B}
+		{6BD69CDA-4875-4045-8B35-6FD4602854F5} = {6BD69CDA-4875-4045-8B35-6FD4602854F5}
 		{1B3063DB-D71C-4A6A-A359-883E8F53A140} = {1B3063DB-D71C-4A6A-A359-883E8F53A140}
 		{D35FD6DB-D704-4BEA-BDAE-C40ABFB5B13E} = {D35FD6DB-D704-4BEA-BDAE-C40ABFB5B13E}
@@ -396,4 +398,10 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Operators.Views.GraphVisualization.Views-3.3", "HeuristicLab.Operators.Views.GraphVisualization.Views\3.3\HeuristicLab.Operators.Views.GraphVisualization.Views-3.3.csproj", "{0C39A349-1979-419A-89BD-E4E2F26BD287}"
+EndProject
+Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "HeuristicLab.MPInet", "HeuristicLab.MPInet", "{DFBAE699-3B5F-42BE-B9C1-04D523DC7B12}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.MPInet-1.0.0", "HeuristicLab.ExtLibs\HeuristicLab.MPInet\1.0.0\HeuristicLab.MPInet-1.0.0.csproj", "{C47EEE60-DF91-46DB-9B78-F2C2301D6FE7}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Operators.MPISupport-3.3", "HeuristicLab.Operators.MPISupport\3.3\HeuristicLab.Operators.MPISupport-3.3.csproj", "{6BD69CDA-4875-4045-8B35-6FD4602854F5}"
 EndProject
 Global
@@ -1850,4 +1858,28 @@
 		{0C39A349-1979-419A-89BD-E4E2F26BD287}.Release|x86.ActiveCfg = Release|x86
 		{0C39A349-1979-419A-89BD-E4E2F26BD287}.Release|x86.Build.0 = Release|x86
+		{C47EEE60-DF91-46DB-9B78-F2C2301D6FE7}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{C47EEE60-DF91-46DB-9B78-F2C2301D6FE7}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{C47EEE60-DF91-46DB-9B78-F2C2301D6FE7}.Debug|x64.ActiveCfg = Debug|x64
+		{C47EEE60-DF91-46DB-9B78-F2C2301D6FE7}.Debug|x64.Build.0 = Debug|x64
+		{C47EEE60-DF91-46DB-9B78-F2C2301D6FE7}.Debug|x86.ActiveCfg = Debug|x86
+		{C47EEE60-DF91-46DB-9B78-F2C2301D6FE7}.Debug|x86.Build.0 = Debug|x86
+		{C47EEE60-DF91-46DB-9B78-F2C2301D6FE7}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{C47EEE60-DF91-46DB-9B78-F2C2301D6FE7}.Release|Any CPU.Build.0 = Release|Any CPU
+		{C47EEE60-DF91-46DB-9B78-F2C2301D6FE7}.Release|x64.ActiveCfg = Release|x64
+		{C47EEE60-DF91-46DB-9B78-F2C2301D6FE7}.Release|x64.Build.0 = Release|x64
+		{C47EEE60-DF91-46DB-9B78-F2C2301D6FE7}.Release|x86.ActiveCfg = Release|x86
+		{C47EEE60-DF91-46DB-9B78-F2C2301D6FE7}.Release|x86.Build.0 = Release|x86
+		{6BD69CDA-4875-4045-8B35-6FD4602854F5}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{6BD69CDA-4875-4045-8B35-6FD4602854F5}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{6BD69CDA-4875-4045-8B35-6FD4602854F5}.Debug|x64.ActiveCfg = Debug|x64
+		{6BD69CDA-4875-4045-8B35-6FD4602854F5}.Debug|x64.Build.0 = Debug|x64
+		{6BD69CDA-4875-4045-8B35-6FD4602854F5}.Debug|x86.ActiveCfg = Debug|x86
+		{6BD69CDA-4875-4045-8B35-6FD4602854F5}.Debug|x86.Build.0 = Debug|x86
+		{6BD69CDA-4875-4045-8B35-6FD4602854F5}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{6BD69CDA-4875-4045-8B35-6FD4602854F5}.Release|Any CPU.Build.0 = Release|Any CPU
+		{6BD69CDA-4875-4045-8B35-6FD4602854F5}.Release|x64.ActiveCfg = Release|x64
+		{6BD69CDA-4875-4045-8B35-6FD4602854F5}.Release|x64.Build.0 = Release|x64
+		{6BD69CDA-4875-4045-8B35-6FD4602854F5}.Release|x86.ActiveCfg = Release|x86
+		{6BD69CDA-4875-4045-8B35-6FD4602854F5}.Release|x86.Build.0 = Release|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
@@ -1862,4 +1894,5 @@
 		{782DDDA3-A7A3-404E-B751-6200CE2D5EF3} = {07BCBC57-3E15-4582-B306-C046E516C49C}
 		{189F7770-5540-4832-B9A0-82474009680C} = {07BCBC57-3E15-4582-B306-C046E516C49C}
+		{DFBAE699-3B5F-42BE-B9C1-04D523DC7B12} = {07BCBC57-3E15-4582-B306-C046E516C49C}
 		{99AD3658-DB36-4E26-B4CC-6FEAACC5C88C} = {7F485A48-A80F-4454-9A9B-7B126B43861C}
 		{678E2145-8152-4E19-9646-07D439D00301} = {99AD3658-DB36-4E26-B4CC-6FEAACC5C88C}
@@ -1897,4 +1930,5 @@
 		{FC841674-62A7-4055-BE91-E41944B6C606} = {91243D2B-77EB-4922-BEB0-78C6AB1DEEDC}
 		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6} = {91243D2B-77EB-4922-BEB0-78C6AB1DEEDC}
+		{C47EEE60-DF91-46DB-9B78-F2C2301D6FE7} = {DFBAE699-3B5F-42BE-B9C1-04D523DC7B12}
 	EndGlobalSection
 EndGlobal