Index: /branches/MPI/HeuristicLab 3.3.sln
===================================================================
--- /branches/MPI/HeuristicLab 3.3.sln	(revision 6346)
+++ /branches/MPI/HeuristicLab 3.3.sln	(revision 6347)
@@ -100,4 +100,5 @@
 		{2C429157-9C34-4DD3-9D5F-B444B751E39A} = {2C429157-9C34-4DD3-9D5F-B444B751E39A}
 		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A} = {3BD61258-31DA-4B09-89C0-4F71FEF5F05A}
+		{62C3B458-430E-4EF4-8250-C50BCF94D035} = {62C3B458-430E-4EF4-8250-C50BCF94D035}
 		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6} = {DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6}
 		{96E5ED5B-187D-4012-9CDA-D85CDAD38342} = {96E5ED5B-187D-4012-9CDA-D85CDAD38342}
@@ -404,4 +405,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Operators.MPISupport-3.3", "HeuristicLab.Operators.MPISupport\3.3\HeuristicLab.Operators.MPISupport-3.3.csproj", "{6BD69CDA-4875-4045-8B35-6FD4602854F5}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "MPIAlgorithmRunner", "HeuristicLab.ExtLibs\HeuristicLab.MPInet\MPIAlgorithmRunner\MPIAlgorithmRunner.csproj", "{62C3B458-430E-4EF4-8250-C50BCF94D035}"
 EndProject
 Global
@@ -1882,4 +1885,16 @@
 		{6BD69CDA-4875-4045-8B35-6FD4602854F5}.Release|x86.ActiveCfg = Release|x86
 		{6BD69CDA-4875-4045-8B35-6FD4602854F5}.Release|x86.Build.0 = Release|x86
+		{62C3B458-430E-4EF4-8250-C50BCF94D035}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{62C3B458-430E-4EF4-8250-C50BCF94D035}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{62C3B458-430E-4EF4-8250-C50BCF94D035}.Debug|x64.ActiveCfg = Debug|x64
+		{62C3B458-430E-4EF4-8250-C50BCF94D035}.Debug|x64.Build.0 = Debug|x64
+		{62C3B458-430E-4EF4-8250-C50BCF94D035}.Debug|x86.ActiveCfg = Debug|x86
+		{62C3B458-430E-4EF4-8250-C50BCF94D035}.Debug|x86.Build.0 = Debug|x86
+		{62C3B458-430E-4EF4-8250-C50BCF94D035}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{62C3B458-430E-4EF4-8250-C50BCF94D035}.Release|Any CPU.Build.0 = Release|Any CPU
+		{62C3B458-430E-4EF4-8250-C50BCF94D035}.Release|x64.ActiveCfg = Release|x64
+		{62C3B458-430E-4EF4-8250-C50BCF94D035}.Release|x64.Build.0 = Release|x64
+		{62C3B458-430E-4EF4-8250-C50BCF94D035}.Release|x86.ActiveCfg = Release|x86
+		{62C3B458-430E-4EF4-8250-C50BCF94D035}.Release|x86.Build.0 = Release|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
@@ -1931,4 +1946,5 @@
 		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6} = {91243D2B-77EB-4922-BEB0-78C6AB1DEEDC}
 		{C47EEE60-DF91-46DB-9B78-F2C2301D6FE7} = {DFBAE699-3B5F-42BE-B9C1-04D523DC7B12}
+		{62C3B458-430E-4EF4-8250-C50BCF94D035} = {DFBAE699-3B5F-42BE-B9C1-04D523DC7B12}
 	EndGlobalSection
 EndGlobal
Index: /branches/MPI/HeuristicLab.ExtLibs/HeuristicLab.MPInet/1.0.0/HeuristicLabMPInetPlugin.cs
===================================================================
--- /branches/MPI/HeuristicLab.ExtLibs/HeuristicLab.MPInet/1.0.0/HeuristicLabMPInetPlugin.cs	(revision 6346)
+++ /branches/MPI/HeuristicLab.ExtLibs/HeuristicLab.MPInet/1.0.0/HeuristicLabMPInetPlugin.cs	(revision 6347)
@@ -25,5 +25,5 @@
   [Plugin("HeuristicLab.MPInet", "1.0.0")]
   [PluginFile("HeuristicLab.MPInet-1.0.0.dll", PluginFileType.Assembly)]
-  [PluginFile("MPI.dll", PluginFileType.Assembly)]
+  [PluginFile("MPI.dll", PluginFileType.Data)]
   [PluginFile("MPI.XML", PluginFileType.Data)]
   [PluginFile("MPInet License.txt", PluginFileType.License)]
Index: /branches/MPI/HeuristicLab.ExtLibs/HeuristicLab.MPInet/MPIAlgorithmRunner/Howto.txt
===================================================================
--- /branches/MPI/HeuristicLab.ExtLibs/HeuristicLab.MPInet/MPIAlgorithmRunner/Howto.txt	(revision 6347)
+++ /branches/MPI/HeuristicLab.ExtLibs/HeuristicLab.MPInet/MPIAlgorithmRunner/Howto.txt	(revision 6347)
@@ -0,0 +1,2 @@
+﻿-> Download the Microsoft Compute Cluser Pack from http://www.microsoft.com/downloads/en/details.aspx?FamilyID=D8462378-2F68-409D-9CB3-02312BC23BFD
+-> Execute the parallel version using mpiexec.exe -n 2 MPIAlgorithmRunner.exe MPI_ISLAND_GA.hl MPI_ISLAND_GA_RESULT
Index: /branches/MPI/HeuristicLab.ExtLibs/HeuristicLab.MPInet/MPIAlgorithmRunner/MPIAlgorithmRunner.csproj
===================================================================
--- /branches/MPI/HeuristicLab.ExtLibs/HeuristicLab.MPInet/MPIAlgorithmRunner/MPIAlgorithmRunner.csproj	(revision 6347)
+++ /branches/MPI/HeuristicLab.ExtLibs/HeuristicLab.MPInet/MPIAlgorithmRunner/MPIAlgorithmRunner.csproj	(revision 6347)
@@ -0,0 +1,152 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="4.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">x86</Platform>
+    <ProductVersion>8.0.30703</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{62C3B458-430E-4EF4-8250-C50BCF94D035}</ProjectGuid>
+    <OutputType>Exe</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>MPIAlgorithmRunner</RootNamespace>
+    <AssemblyName>MPIAlgorithmRunner</AssemblyName>
+    <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
+    <TargetFrameworkProfile>Client</TargetFrameworkProfile>
+    <FileAlignment>512</FileAlignment>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
+    <PlatformTarget>x86</PlatformTarget>
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
+    <PlatformTarget>x86</PlatformTarget>
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|AnyCPU'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>AnyCPU</PlatformTarget>
+    <CodeAnalysisLogFile>bin\Debug\MPIAlgorithmRunner.exe.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
+    <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+    <CodeAnalysisRuleSetDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
+    <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|AnyCPU'">
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>AnyCPU</PlatformTarget>
+    <CodeAnalysisLogFile>bin\Release\MPIAlgorithmRunner.exe.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
+    <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+    <CodeAnalysisRuleSetDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
+    <CodeAnalysisIgnoreBuiltInRuleSets>false</CodeAnalysisIgnoreBuiltInRuleSets>
+    <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+    <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
+    <CodeAnalysisFailOnMissingRules>false</CodeAnalysisFailOnMissingRules>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x64'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x64\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <CodeAnalysisLogFile>bin\Debug\MPIAlgorithmRunner.exe.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
+    <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+    <CodeAnalysisRuleSetDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
+    <CodeAnalysisIgnoreBuiltInRuleSets>false</CodeAnalysisIgnoreBuiltInRuleSets>
+    <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+    <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
+    <CodeAnalysisFailOnMissingRules>false</CodeAnalysisFailOnMissingRules>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
+    <OutputPath>bin\x64\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <CodeAnalysisLogFile>bin\Release\MPIAlgorithmRunner.exe.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
+    <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+    <CodeAnalysisRuleSetDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
+    <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="MPI, Version=1.0.0.0, Culture=neutral, PublicKeyToken=29b4a045737654fe, processorArchitecture=MSIL">
+      <HintPath>..\HeuristicLab.ExtLibs\HeuristicLab.MPInet\1.0.0\MPI.dll</HintPath>
+    </Reference>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="Microsoft.CSharp" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="Program.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
+      <Project>{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}</Project>
+      <Name>HeuristicLab.Common-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
+      <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
+      <Name>HeuristicLab.Core-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\1.0.0\HeuristicLab.MPInet-1.0.0.csproj">
+      <Project>{C47EEE60-DF91-46DB-9B78-F2C2301D6FE7}</Project>
+      <Name>HeuristicLab.MPInet-1.0.0</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\..\HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj">
+      <Project>{14AB8D24-25BC-400C-A846-4627AA945192}</Project>
+      <Name>HeuristicLab.Optimization-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj">
+      <Project>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</Project>
+      <Name>HeuristicLab.Persistence-3.3</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="MPI_ISLAND_GA.hl">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </None>
+  </ItemGroup>
+  <ItemGroup>
+    <Content Include="Howto.txt" />
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: /branches/MPI/HeuristicLab.ExtLibs/HeuristicLab.MPInet/MPIAlgorithmRunner/Program.cs
===================================================================
--- /branches/MPI/HeuristicLab.ExtLibs/HeuristicLab.MPInet/MPIAlgorithmRunner/Program.cs	(revision 6347)
+++ /branches/MPI/HeuristicLab.ExtLibs/HeuristicLab.MPInet/MPIAlgorithmRunner/Program.cs	(revision 6347)
@@ -0,0 +1,47 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.Xml;
+using System.Threading;
+
+namespace MPIAlgorithmRunner {
+  class Program {
+    EventWaitHandle waitHandle = new EventWaitHandle(false, EventResetMode.ManualReset);
+
+    static void Main(string[] args) {
+      if (args.Length != 2) {
+        Console.WriteLine("Args:" + args.Length);
+
+        throw new ArgumentException("You must provide two arguments - the algorithm file and the result file");
+      }
+
+      string fileName = args[0];
+      string resultName = args[1];
+
+      using (new MPI.Environment(ref args)) {
+        Program p = new Program();
+        p.StartAlgorithm(fileName, resultName + MPI.Communicator.world.Rank + ".hl");
+      }
+    }
+
+    public void StartAlgorithm(string fileName, string resultName) {
+      IAlgorithm alg = XmlParser.Deserialize<HeuristicLab.Optimization.IAlgorithm>(fileName);
+
+      alg.Stopped += new EventHandler(algorithm_Stopped);
+      waitHandle.Reset();
+
+      alg.Prepare(true);
+      alg.Start();
+
+      waitHandle.WaitOne();
+
+      XmlGenerator.Serialize(alg, resultName);
+    }
+
+    void algorithm_Stopped(object sender, EventArgs e) {
+      waitHandle.Set();
+    }
+  }
+}
Index: /branches/MPI/HeuristicLab.ExtLibs/HeuristicLab.MPInet/MPIAlgorithmRunner/Properties/AssemblyInfo.cs
===================================================================
--- /branches/MPI/HeuristicLab.ExtLibs/HeuristicLab.MPInet/MPIAlgorithmRunner/Properties/AssemblyInfo.cs	(revision 6347)
+++ /branches/MPI/HeuristicLab.ExtLibs/HeuristicLab.MPInet/MPIAlgorithmRunner/Properties/AssemblyInfo.cs	(revision 6347)
@@ -0,0 +1,36 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("MPIAlgorithmRunner")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("Microsoft")]
+[assembly: AssemblyProduct("MPIAlgorithmRunner")]
+[assembly: AssemblyCopyright("Copyright © Microsoft 2011")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("b2b1aeaf-6a56-4e66-8e34-c78feef5bbd8")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("1.0.0.0")]
+[assembly: AssemblyFileVersion("1.0.0.0")]
Index: /branches/MPI/HeuristicLab.Operators.MPISupport/3.3/HeuristicLab.Operators.MPISupport-3.3.csproj
===================================================================
--- /branches/MPI/HeuristicLab.Operators.MPISupport/3.3/HeuristicLab.Operators.MPISupport-3.3.csproj	(revision 6346)
+++ /branches/MPI/HeuristicLab.Operators.MPISupport/3.3/HeuristicLab.Operators.MPISupport-3.3.csproj	(revision 6347)
@@ -114,4 +114,6 @@
     <None Include="HeuristicLabOperatorsMPISupportPlugin.cs.frame" />
     <Compile Include="HeuristicLabOperatorsMPISupportPlugin.cs" />
+    <Compile Include="MPITransportWrapper.cs" />
+    <Compile Include="MPIUnidirectionalRingMigrator.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
@@ -121,4 +123,24 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
+      <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
+      <Name>HeuristicLab.Collections-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
+      <Project>{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}</Project>
+      <Name>HeuristicLab.Common-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
+      <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
+      <Name>HeuristicLab.Core-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Operators\3.3\HeuristicLab.Operators-3.3.csproj">
+      <Project>{23DA7FF4-D5B8-41B6-AA96-F0561D24F3EE}</Project>
+      <Name>HeuristicLab.Operators-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj">
+      <Project>{14AB8D24-25BC-400C-A846-4627AA945192}</Project>
+      <Name>HeuristicLab.Optimization-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj">
       <Project>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</Project>
Index: /branches/MPI/HeuristicLab.Operators.MPISupport/3.3/HeuristicLabOperatorsMPISupportPlugin.cs.frame
===================================================================
--- /branches/MPI/HeuristicLab.Operators.MPISupport/3.3/HeuristicLabOperatorsMPISupportPlugin.cs.frame	(revision 6346)
+++ /branches/MPI/HeuristicLab.Operators.MPISupport/3.3/HeuristicLabOperatorsMPISupportPlugin.cs.frame	(revision 6347)
@@ -29,5 +29,10 @@
   [PluginFile("HeuristicLab.Operators.MPISupport-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.MPInet", "1.0.0")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
   public class HeuristicLabOperatorsMPISupportPlugin : PluginBase {
   }
Index: /branches/MPI/HeuristicLab.Operators.MPISupport/3.3/MPITransportWrapper.cs
===================================================================
--- /branches/MPI/HeuristicLab.Operators.MPISupport/3.3/MPITransportWrapper.cs	(revision 6347)
+++ /branches/MPI/HeuristicLab.Operators.MPISupport/3.3/MPITransportWrapper.cs	(revision 6347)
@@ -0,0 +1,75 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Runtime.Serialization;
+using HeuristicLab.Core;
+using System.IO;
+using HeuristicLab.Persistence.Default.Xml;
+
+namespace HeuristicLab.Operators.MPISupport {
+  /// <summary>
+  /// A simple wrapper to transport items over the message passing interface
+  /// </summary>
+  [Serializable]
+  class MPITransportWrapper<T>: ISerializable where T: class, IItem {
+    [NonSerialized]
+    private T innerItem;
+
+    public T InnerItem {
+      get {
+        return innerItem;
+      }
+    }
+
+    public MPITransportWrapper(T item) {
+      innerItem = item;
+    }
+
+    protected MPITransportWrapper(SerializationInfo info, StreamingContext context) {
+      MemoryStream stream = new MemoryStream(info.GetValue("Item", typeof(byte[])) as byte[]);
+      if (stream != null)
+        innerItem = XmlParser.Deserialize(stream) as T;
+      else
+        innerItem = null;
+    }
+
+    #region ISerializable Members
+
+    public void GetObjectData(SerializationInfo info, StreamingContext context) {
+      object value = null;
+
+      if (innerItem != null) {
+        MemoryStream stream = new MemoryStream();
+        XmlGenerator.Serialize(innerItem, stream);
+
+        value = stream.GetBuffer();
+      } 
+        
+      info.AddValue("Item", value);     
+    }
+
+    #endregion
+  }
+}
Index: /branches/MPI/HeuristicLab.Operators.MPISupport/3.3/MPIUnidirectionalRingMigrator.cs
===================================================================
--- /branches/MPI/HeuristicLab.Operators.MPISupport/3.3/MPIUnidirectionalRingMigrator.cs	(revision 6347)
+++ /branches/MPI/HeuristicLab.Operators.MPISupport/3.3/MPIUnidirectionalRingMigrator.cs	(revision 6347)
@@ -0,0 +1,75 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Operators.MPISupport {
+  [Item("MPIUnidirectionalRingMigrator", "A unidirectional ring migrator that utilizes MPI if available.")]
+  [StorableClass]
+  public class MPIUnidirectionalRingMigrator : SingleSuccessorOperator {
+    [StorableConstructor]
+    private MPIUnidirectionalRingMigrator(bool deserializing) : base(deserializing) { }
+    private MPIUnidirectionalRingMigrator(MPIUnidirectionalRingMigrator original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MPIUnidirectionalRingMigrator(this, cloner);
+    }
+    public MPIUnidirectionalRingMigrator()
+      : base() {
+    }
+
+    public override IOperation Apply() {
+      if (MPI.Communicator.world != null) {
+        int size = MPI.Communicator.world.Group.Size;
+        if (size > 1) {
+          int i = MPI.Communicator.world.Rank;
+          IScope scope = ExecutionContext.Scope;
+
+          IScope emigrants = scope.SubScopes[1];
+          scope.SubScopes.Remove(emigrants);
+          int recipent = (i + 1) % size;
+
+          Console.WriteLine("MIGRATE " + i + " TO " + recipent);
+          MPI.Communicator.world.Send<MPITransportWrapper<IScope>>(
+            new MPITransportWrapper<IScope>(emigrants), recipent, 0);
+
+          IScope immigrants = null;
+          int sender = i - 1;
+          if (sender < 0)
+            sender = size - 1;
+
+          Console.WriteLine("MIGRATE " + i + " FROM " + sender);
+          immigrants = MPI.Communicator.world.Receive<MPITransportWrapper<IScope>>(sender, 0).InnerItem;
+
+          scope.SubScopes.Add(immigrants);
+        }
+      }
+
+      return base.Apply();
+    }
+  }
+}
Index: /branches/MPI/HeuristicLab/3.3/Files.txt
===================================================================
--- /branches/MPI/HeuristicLab/3.3/Files.txt	(revision 6346)
+++ /branches/MPI/HeuristicLab/3.3/Files.txt	(revision 6347)
@@ -112,4 +112,7 @@
 HeuristicLab.ExtLibs\HeuristicLab.MPInet\1.0.0:MPI.XML
 HeuristicLab.ExtLibs\HeuristicLab.MPInet\1.0.0:MPInet License.txt
+HeuristicLab.ExtLibs\HeuristicLab.MPInet\MPIAlgorithmRunner:MPIAlgorithmRunner.exe
+HeuristicLab.ExtLibs\HeuristicLab.MPInet\MPIAlgorithmRunner:MPI_ISLAND_GA.hl
+HeuristicLab.ExtLibs\HeuristicLab.MPInet\MPIAlgorithmRunner:Howto.txt
 
 HeuristicLab.ExtLibs\HeuristicLab.Netron\3.0.2672.12446\Netron.Diagramming.Core-3.0.2672.12446:Netron.Diagramming.Core-3.0.2672.12446.dll